#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>

#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <sstream>
#include <cassert>
#include <cmath>
#include <queue>

using namespace std;

#define fr(i,a,b) for ( int i = ( a ); i <= ( b ); ++i )
#define fi( a ) for ( int i = 0; i < ( a ); ++i )
#define fj( a ) for ( int j = 0; j < ( a ); ++j )
#define fk( a ) for ( int k = 0; k < ( a ); ++k )
#define CLR( a, b ) memset( ( a ), ( b ), sizeof ( a ) )
#define clr( a ) memset( ( a ), 0, sizeof ( a ) )
#define pb push_back
#define mp make_pair
#define all( v ) ( v ).begin(), ( v ).end()
#define X first
#define Y second

typedef long long ll;
typedef vector < int > vi;
typedef pair < int, int > pii;

// Consts

const double CRITIC_DST = 0.10;
const int CRITIC_AMOUNT = 1;
const double eps = 1e-9;
const int inf = 1 << 30;
const double GOOD_SJAB = 0.07;
const double PI = 3.1415926535897932;
const double SHOOT_ANGLE = PI / 6;
const int AM_SHOOT = 50;
const double R_BIG = 0.43;
const double R_SMALL = 0.1;

// Globals
double pX, pY;


double alpha;
World *world;
bool sjabivaemsa = false;
pair < double, double > kudasjabivaemsa;
int idKudaSjabivaemsa;
double cornersX[4] = { 0.2, 0.2, 0.8, 0.8 };
double cornersY[4] = { 0.2, 0.8, 0.8, 0.2 };
bool first = true;
double cur_r, cur_ang;
bool start;
int enemys;

// Base functions

double dst( double X1, double Y1, double X2, double Y2 )
{
	return ( hypot( X1 - X2, Y1 - Y2 ) );
}

bool eshesjabivaemsa()
{
	if ( sjabivaemsa == false ) return ( false );
	if ( dst( pX, pY, cornersX[idKudaSjabivaemsa], cornersY[idKudaSjabivaemsa] ) <= GOOD_SJAB )
		return ( false );	
	return ( true );
}

// We run in circle
/////////////////////////////////////////////////////


void initRunCircle()
{
	alpha = 0;
}

pair < double, double > doRunCircle()
{
    alpha += 0.05;
    return ( mp( cos( alpha ), sin( alpha ) ) );
}
///////////////////////////////////////////////////////

// check if it's all right in our place

bool zaebis( double x, double y, int & nearUs )
{
	nearUs = 0;
	for ( int j = 0; j < world->MAXMONSTERS; j++)
		if (world->monsters[j].ClassName >= 0)
		{
			double mx = world->monsters[j].PositionX;
			double my = world->monsters[j].PositionY;
			if ( dst( x, y, mx, my ) <= CRITIC_DST )
			{
				++nearUs;
			}
		}
	return ( nearUs <= CRITIC_AMOUNT );
}


pair < double, double > chooseAngle()
{
	int mi = inf;
	int id = -1;
	if ( first )
	{
		
		fi( 4 )
		{
			double cx = cornersX[i];
			double cy = cornersY[i];

			int cam = 0;
			zaebis( cx, cy, cam );
			if ( mi > cam )
			{
				mi = cam;
				id = i;
			}
		}
	}
	else
	{
		int cc = idKudaSjabivaemsa;
		fr(i,-1,1) if ( i != 0 )
		{
			double cx = cornersX[i];
			double cy = cornersY[i];

			int cam = 0;
			zaebis( cx, cy, cam );
			if ( mi > cam )
			{
				mi = cam;
				id = i;
			}
		}
	}
	idKudaSjabivaemsa = id;
	double dirx = cornersX[id] - world->player.PositionX;
	double diry = cornersY[id] - world->player.PositionY;
	kudasjabivaemsa = mp( dirx, diry );
	return ( mp( dirx, diry ) );

}

// SHOOT
vector < double > mx;
vector < double > my;
vector < double > mang;
double curAngle;
int hadShoot = 0;
double deltaShoot;
bool small = false;
bool big = false;

double findSector()
{
	
	mx.clear();
	my.clear();
	mang.clear();
	/*mx.reserve( world->MAXMONSTERS );
	my.reserve( world->MAXMONSTERS );
	mang.reserve( world->MAXMONSTERS );*/

	for ( int j = 0; j < world->MAXMONSTERS; j++)
		if ( world->monsters[j].ClassName >= 0) 
		{
			mx.pb( world->monsters[j].PositionX - pX );
			my.pb( world->monsters[j].PositionY - pY );
			if ( fabs( mx.back() ) < 1e-5 && my.back() < 1e-5 )
				mang.pb( 0 );
			else
				mang.pb( atan2( my.back(), mx.back() ) );
		}
	if ( mang.size() == 0 ) return ( 0 );
	sort( all( mang ));
	int n = mang.size();
	fi( n )
	{
		mang.pb( mang[i] + PI * 2 );
	}
	double bStart = -1;
	int bAm = -1;
	cout << n << endl;
	fi( n )
	{
		int cnt = 0;
		double idd = -1;
		fj( n )
		{
			int k = i + j;
			k %= mang.size();
			if ( fabs( mang[i] - mang[k] ) <= SHOOT_ANGLE )
			{
				++cnt;
				idd = mang[k]; 
			}
			else
				break;
		}
		if ( cnt > bAm )
		{
			bStart = ( mang[i] + idd ) / 2;
			deltaShoot = ( mang[i] + idd ) / 600;
			bAm = cnt;
		}
		
	}
	
	cout << bStart << endl;
	return ( bStart );
}

pair < double, double > makeShoot()
{
	if ( hadShoot > AM_SHOOT )
	{
		curAngle = findSector();
		hadShoot = 0;
	}
	pair < double, double > ret = mp( cos( curAngle ), sin( curAngle ) );
	curAngle += deltaShoot;
	++hadShoot;
	return ( ret );
}

pair < double, double > shootZaeb()
{
	//pair < double, double > dir = kudasjabivaemsa;
	int id = -1;
	double bdst = 1e100;
	for ( int j = 0; j < world->MAXMONSTERS; j++)
		if ( world->monsters[j].ClassName >= 0) 
		{
			double dd = dst( pX, pY, world->monsters[j].PositionX, world->monsters[j].PositionY );
			if ( dd < bdst )
			{
				dd = bdst;
				id = j;
			}
		}
	return ( mp( world->monsters[id].PositionX - pX, world->monsters[id].PositionY - pY ) ); 
}

/////////////////////////////////////

pair < double, double > toBig()
{
	if (dst(0.5, 0.5, pX, pY) < R_BIG)
	{
		cur_ang += 0.005;
		return (make_pair(cos(cur_ang), sin(cur_ang)));
	}
	else
	{
		big = false;
		double x = pX - 0.5;
		double y = pY - 0.5;
		cur_ang = atan2( -y, x );
		return (make_pair(-y, x));
	}
}

pair < double, double > toSmall()
{
	if ( dst( 0.5, 0.5, pX, pY ) > R_SMALL )
	{
		double x = pX - 0.5;
		double y = pY - 0.5;
		cur_ang = atan2( -y + (0.5 - pX), x + (0.5 - pY)); 
		return ( mp( -y + (0.5 - pX), x + (0.5 - pY)) );
	}
	else
	{
		small = false;
		double x = pX - 0.5;
		double y = pY - 0.5;
		cur_ang = atan2( -y , x ); 

		return (make_pair(-y, x));
	}

}

pair < double, double > onCircle()
{
	cur_ang += 0.01;
	return (make_pair(cos(cur_ang), sin(cur_ang)));
}

int amountOfEnemys()
{
	int res = 0;
	for ( int j = 0; j < world->MAXMONSTERS; j++)
		if ( world->monsters[j].ClassName >= 0) 
			++res;
	return (res);
}

bool forward = true;

pair < double, double > move()
{
	if (start)
	{	
		cur_ang = PI;
		if (pX < 0.4)
		{
			enemys = amountOfEnemys();
			start = false;
			big = true;
		}
		else
		{
			if (pX > 0.80)
				forward = false;
			if (forward)
				return (make_pair(1, 0));
			else
				return (make_pair(-1, 0));
		}
	}
	if (!start)
	{
		if (big || small)
			enemys = amountOfEnemys();
		if (big)
			return (toBig());
		if (small)
			return (toSmall());
		
		int curEn = amountOfEnemys();
		if (curEn > enemys)
		{
			small = true;
			enemys = curEn;
			return (toSmall());
		}
		else
		{
			big = true;
			enemys = curEn;
			return (toBig());
		}
	}
}

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	world = new World(argv[1], atoi(argv[2]));
	initRunCircle();

	cur_r = 0;
	cur_ang = 0;
	start = true;
	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);
		
		// think this fucken moving
		
		pX = world->player.PositionX;
		pY = world->player.PositionY;
		pair < double, double > nextDirection;

		int nn;

		///*if ( eshesjabivaemsa() )
		//{
		//	nextDirection = kudasjabivaemsa;
		//}
		//else
		//{*/
		////	sjabivaemsa = false;
		//	if ( zaebis( world->player.PositionX, world->player.PositionY, nn ) )
		//	{
		//		nextDirection = doRunCircle(); 	
		//	}
		//	else
		//	{
		////		sjabivaemsa = true;
		//		nextDirection = chooseAngle();
		////		if ( first ) first = false;
		//	}
		////}
		////Run in circles (set direction)
		/*if ( world->player.Time > 1100 )
		{
			if ( zaebis( world->player.PositionX, world->player.PositionY, nn ) )
			{
				nextDirection = doRunCircle(); 	
			}
			else
			{
				nextDirection = chooseAngle();
			}
		}
		else*/
			nextDirection = move();
		world->run( nextDirection.X, nextDirection.Y );

		pair < double, double > ret;
		//Choose the first monster that is still alive

		ret = makeShoot();

		world->shoot( ret.X, ret.Y );
	}

	return 0;
}
