#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#define PosX PositionX
#define PosY PositionY
#define VelX VelocityX
#define VelY VelocityY
#define mk() makeMove()
#define pl player
#define fl float
#define mon monsters
using namespace std;



float len(float x, float y) {
	return x*x+y*y;
}
const double PI=3.1415926535897932384626433832795;
const float eps_cir = 0.1, eps_ang = 0.1; 
World *w;
                    
float shoot(float vp, float x, float y, float vx, float vy) {
  	if (len(vx,vy) > 0.95 * vp)
  		return atan2f(y, x);
	float L = len(x, y) / (vp + len(vx,vy)), R = len(x, y) / (vp - len(vx,vy));
	for(int it=0; it<50; it++) {
		float t = (L+R)*0.5, x1 = x + t*vx, y1 = y + t*vy;
		if (len(x1, y1) / vp < t) L = t;
		else R = t;
   	}
   	float t = (L+R)*0.5;
   	return atan2f(y + t*vy, x+t*vx);
}

float v[500];
int nv;

int cnt(fl x,fl y){
	int res = 0;
	for(int i = 0; i < nv; i++)
	if (x <= v[i] && v[i] <= y)
		res++;
	return res;	
}
void initV(){
	nv=0;
	int i;
	for (int j=0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0)
			v[nv++] = atan2f(w->monsters[j].PositionY-w->player.PositionY, w->monsters[j].PositionX-w->player.PositionX);
    //sort(v,v+nv);
    for(i=0;i<nv;i++)
		if(v[i]<0.0) v[i]+=2*PI;
	sort(v,v+nv);


}
fl dProd(fl x1,fl y1,fl x2,fl y2){
	return x1*x2+ y1*y2;
}
bool out(fl x,fl y){
	int i,ans=0;
	for(i=0;i<w->MAXMONSTERS;i++){
		if(w->mon[i].ClassName<0) continue;
//		if(len(w->mon[i].PosX-w->pl.PosX,w->mon[i].PosY-w->pl.PosY)>0.1) continue;
		if(dProd(w->mon[i].PosX-w->pl.PosX,w->mon[i].PosY-w->pl.PosY,x,y) >= 0.0) ans++;
	}
	return ans<=10;
}

pair<float,float> circle(World *w) {
	float v[2*w->MAXMONSTERS];
	int nv=0;
	for (int j=0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0 && len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY) < eps_cir)
			v[nv++] = atan2f(w->monsters[j].PositionY-w->player.PositionY, w->monsters[j].PositionX-w->player.PositionX);
	for (int i=0; i<nv; i++)
		v[nv+i] = v[i] + PI + PI;
	int nj = 0, ni = 0;
	for (int j, i=0; i<nv; i++) {
		for (j=i+1; j<nv+nv && v[j]-v[i] < 0.8*PI; j++);
		if (j-i > nj - ni)
			ni = i, nj = j;
	}
	float mv = nj ? v[nj] + 0.2*PI : 0;
	float minlen = 2;
	int id=-1;
	for ( int j = 0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0 && len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY) < minlen)
			minlen = len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY), id = j;
	float sh = shoot(w->pl.BulletVelocity, w->monsters[id].PosX - w->player.PosX, w->monsters[id].PosY - w->player.PosY, w->monsters[id].VelX, w->monsters[id].VelY);
	w->run(cos(mv),sin(mv));
	w->shoot(cos(sh),sin(sh));
	w->mk();
	return make_pair(mv, sh);
}	
fl dist(fl a,fl b){
	fl mx=1.e10;
	int i;
	for(i=0;i<w->MAXMONSTERS;i++){
				if (w->monsters[i].ClassName < 0) continue;
				fl y1=w->monsters[i].PositionY-w->player.PositionY;
				fl x1=w->monsters[i].PositionX-w->player.PositionX;
				fl al=atan2(y1,x1);
				if(al<0.0) al+=2*PI;
				if(a<=al&&al<=b){
					if(len(x1,y1)<mx){
						mx=len(x1,y1);
					
					}	
				}
			}
	 return mx;
}
	
float move_away(World *w,int t) {
	/*float v[w->MAXMONSTERS+1];
	int nv=0;
	for (int j=0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0 && len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY) < eps_cir)
			v[nv++] = atan2f(w->monsters[j].PositionY-w->player.PositionY, w->monsters[j].PositionX-w->player.PositionX);
	sort(v, v+nv);
	v[nv] = v[0] + 2*PI;
	float dv = 0, rv=0;
	for (int i=0; i<nv; i++)
		if (v[i+1] - v[i] > dv)
			dv = v[i+1] - v[i], rv = (v[i]+v[i+1])/2;
	return rv;
	*/
	initV();
		int k=8,e,i,j=-1;
	fl mx=-1;
	for(i=0;i<k;i++){
		e=cnt((2*PI/k)*i,(2*PI/k)*(i+1));
		if(e>mx){
			mx=e;
			j=i;
	    }
	}
	j+=k/2;
	j%=k;
	
	float dv = 0, rv=0,a=(2*PI/k)*j,b=(2*PI/k)*(j+1);
	v[nv] = v[0] + 2*PI;
	for (int i=0; i<nv; i++){
		if(v[i]< a || v[i] > b) continue;
		if (v[i+1] - v[i] > dv)
			dv = v[i+1] - v[i], rv = (v[i]+v[i+1])/2;
	}

	w->run(cos(rv),sin(rv));
	fl x=cos(rv),y=sin(rv);
	fl ee=0.2;
	while(!out(x,y)){
		printf("out\n");
		w->mk();
		if(dist(a,b) < ee){
			//initV();
			j=-1;mx=2;
			for(i=0;i<w->MAXMONSTERS;i++){
				if (w->monsters[i].ClassName < 0) continue;
				fl y1=w->monsters[i].PositionY-w->player.PositionY;
				fl x1=w->monsters[i].PositionX-w->player.PositionX;
				fl al=atan2(y1,x1);
				if(al<0.0) al+=2*PI;
				if(a<=al&&al<=b){
					if(len(x1,y1)<mx){
						mx=len(x1,y1);
						j=i;
					}	
				}
			}
		    i=j;
		    fl y1=w->monsters[i].PositionY-w->player.PositionY;
			fl x1=w->monsters[i].PositionX-w->player.PositionX;
			fl al=atan2(y1,x1);
			shoot(w->pl.BulletVelocity,x1,y1,w->mon[j].VelX,w->mon[i].VelY);
				
		}
		else
		{
			//initV();
						for(i=0;i<w->MAXMONSTERS;i++){
				if(w->mon[i].ClassName<0) continue;
								fl y1=w->monsters[i].PositionY-w->player.PositionY;
				fl x1=w->monsters[i].PositionX-w->player.PositionX;

				shoot(w->pl.BulletVelocity,x1,y1,w->mon[i].VelX,w->mon[i].VelY);
				break;
//						}
			}
		}	
						
	}
	printf("vse\n");
	pair<fl,fl> p;
    while(1){
    	p=circle(w);
    	if(!out(cos(p.first),sin(p.first))) break;
    }
    printf("bugaga\n"); 	
}
float shoot_mass(World *w) {
	float v[2*w->MAXMONSTERS+1];
	int nv=0;
	for (int j=0; j < w->MAXMONSTERS; j++)
		if (w->monsters[j].ClassName >= 0 && len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY))
			v[nv++] = atan2f(w->monsters[j].PositionY-w->player.PositionY, w->monsters[j].PositionX-w->player.PositionX);
	sort(v, v+nv);
	for (int i=0; i<nv; i++)
		v[nv+i] = v[i];
	float sh=0;
	float num = 0;
	for (int j, i=0; i<nv+nv; i++) {
		for (j=i+1; j<nv && v[j]-v[i] < eps_ang; j++)
		if (j-i > num)
			num = (j-i), sh = (v[j-1] + v[i])*0.5;
   	}
   	return sh;
}

//void first(World *w){
//	w.run(1,0);
//	w.mk();
//	while(w->pl.posX<0.85){
//		
//		w.mk();
//	}
//} 

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the w data (and establish connection with the server)
	w = new World(argv[1], atoi(argv[2]));
	//first(w);
	//return 0;
//	first();
	//Infinite loop

	while (1) {
		w->mk();
		move_away(w, 0);
		//Print some information
		
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				w->player.Time, w->player.HitPoints,
				w->player.PosX, w->player.PosY);
		//printf("%d\n",w->player.BulletVelocity);
//		float v = move_away(w);
        		
//		printf("%lf: ",w->player.GunCooldownPeriod);
		//Run in circles (set direction)
//		if(w->player.Time>=120) w->run(cos(v), sin(v));
		/*
		float mv = move_away(w,0);
		w->run(cos(mv), sin(mv));
		float minlen = 2;
		int id=-1;
		for ( int j = 0; j < w->MAXMONSTERS; j++)
			if (w->monsters[j].ClassName >= 0 && len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY) < minlen)
				minlen = len(w->monsters[j].PositionX-w->player.PositionX, w->monsters[j].PositionY-w->player.PositionY), id = j;
		if (id>=0) {
			float ang = shoot(w->pl.BulletVelocity, w->monsters[id].PosX - w->player.PosX, w->monsters[id].PosY - w->player.PosY, w->monsters[id].VelX, w->monsters[id].VelY);
			w->shoot(cos(ang), sin(ang));
		}
//			w->shoot(w->monsters[id].PositionX - w->player.PositionX,
//		  		 w->monsters[id].PositionY - w->player.PositionY);

//		float sh = shoot_mass(w);
		
//		w->shoot(cos(sh), sin(sh));
//		continue;
        */
	}

	return 0;
}
