#include "world.h"

#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <stack>
#include <deque>
#include <queue>
#include <list>
#include <ctime>
 
#define fi(i, n) for (int i = 0; i < n; ++i)
#define fv(i, v) for (int i = 0; i < v.size(); ++i)
#define fab(i, a, b) for (int i = a; i <= b; ++i)
#define fba(i, a, b) for (int i = a; i >= b; --i)

#define V vector
#define P pair
#define LL long long
#define D double

#define VI vector<int>
#define VL vector<long long>
#define VS vector<string>
#define VD vector<double>

#define mp make_pair
#define all(a) a.begin(), a.end()
#define pb push_back
#define sqr(a) a * a 

#define X first
#define Y second

using namespace std;

D px, py;

double otake_monster(CMonster k, D dist)
{
	return k.BiteDamage / (sqrt(k.HitPoints) * (dist / k.MaxVelocity));
}

bool comp_danger(P<D, CMonster> a, P<D, CMonster> b)
{
	D da = otake_monster(a.Y, a.X);
	D db = otake_monster(b.Y, b.X);
	return da < db;
}

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;

	bool k = 1;

	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		px = world->player.PositionX;
		py = world->player.PositionY;

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf ",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

		if (world -> player.PositionY < 0.15)
			k = 0;

		if (k)
		{
			world->run(0, -1);
		}
		else
		{
			alpha += 0.007;
			world->run(cos(alpha), sin(alpha));
		}

		V<P<D, CMonster> > danger;

		double d[360], r[360];

		fi(i, 360)
			d[i] = 0,
			r[i] = 0;

		fi(i, world->MAXMONSTERS)
		{
			D mx = world->monsters[i].PositionX;
			D my = world->monsters[i].PositionY;

			if (world->monsters[i].ClassName < 0)
				continue;
			D angle1 = atan2(world->player.PositionY - world->monsters[i].PositionY,
				world->player.PositionX - world->monsters[i].PositionX);
			D angle2 = atan2(sin(alpha), cos(alpha));
			D diff = angle1 - angle2;
			while (diff > 3.1415927)
				diff -= 3.1415926;
			while (diff < 0)
				diff += 3.1415926;
			//printf(" %lf ", diff);
			//double offset = atan(world->monsters[i].MaxVelocity/world->player.MaxVelocity);
			double offset = 0.75;
			double dist = sqrt(sqr(mx - px) + sqr(my - py));
			if (diff < offset)
				danger.pb(mp(dist, world->monsters[i]));
			if (angle1 < 0)
				angle1 += 2 * 3.1415926;
			int gr = floor(angle1 / 3.1415926 * 180.0);
			if (gr >= 360)
				gr = 359;
			if (gr < 0)
				gr = 0;
			d[gr] += 1 - dist;
		}

		D lb = sqr(px) + sqr(py);
		D lt = sqr(px) + sqr(1 - py);
		D rb = sqr(1 - px) + sqr(py);
		D rt = sqr(1 - px) + sqr(1 - py);

		fi(i, 360)
		{
			fab(offset, -45, 45)
				r[i] += d[(360 + i + offset) % 360];
			if (0 <= i && i <= 90)
				r[i] -= 1000 * rt;
			if (0 <= 90 && i <= 180)
				r[i] -= 1000 * lt;
			if (0 <= 180 && i <= 270)
				r[i] -= 1000 * lb;
			if (0 <= 270 && i <= 360)
				r[i] -= 1000 * rb;
		}
		
		int best = 0;
		fi(i, 360)
			if (r[i] < r[best])
				best = i;

		double run = 1.0 * best / 180.0 * 3.1415926;

		//world->run(cos(run), sin(run));
		printf(" danger = %d\n", danger.size());

		sort(all(danger), comp_danger);

		if (danger.size() == 0)
		{
			D x = 0, y = 0;
			int c = 0;
			for ( int j = 0; j < world->MAXMONSTERS; j++)
				if (world->monsters[j].ClassName >= 0) {
					//Shoot the bastard! (Shoot in the direction of the monster)
					x += world->monsters[j].PositionX;
					y += world->monsters[j].PositionY;
					++c;
					//break;
				}
			world->shoot(x / c - px, y / c - py);
			//world->shoot(-cos(alpha), -sin(alpha));
		}
		else
		{
			int k = rand() % min((int)danger.size(), 5);
			D x = danger[k].second.PositionX - world->player.PositionX;
			D y = danger[k].second.PositionY - world->player.PositionY;
			world->shoot(x, y);
		}
	}

	return 0;
}

