import java.io.IOException;
import java.util.Random;

class Task {

	public static void main(String[] args) throws IOException {
		// Check for enough parameters
		if (args.length < 2) {
			System.err.println("parameters: IP port");
			System.exit(10);
		}

		// Create the world data (and establish connection with the server)
		World world = new World(args[0], Integer.parseInt(args[1]));
		float alpha;

		// Infinite loop
		int monstersN = world.MAXMONSTERS;

		final float v = 0.0025f;
		final float border = 0.1f;

		// PrintWriter writer = new PrintWriter(new File("ss.out"));

		float angle = 0;
		boolean flag = false;
		Random random = new Random(566);

		int move = 0;

		float lastVx = 0;
		float lastVy = 0;

		int toKill = -1;
		float lastHp = Float.POSITIVE_INFINITY;

		int state = 0;

		float[] xs = { 0.1f, 0.9f, 0.9f, 0.1f };
		float[] ys = { 0.1f, 0.1f, 0.9f, 0.9f };
		float[] xs2 = { 0.0f, 1f, 1f, 0f };
		float[] ys2 = { 0.0f, 0f, 1f, 1f };
		int corner = 0;
		int start = -1;

		int[] cornC = new int[4];
		
		float toGoX = -100;
		float toGoY = -100;

		while (true) {
			++move;
			world.makeMove();
			float px = world.player.PositionX;
			float py = world.player.PositionY;
			int monsters = 0;
			for (int i = 0; i < monstersN; ++i) {
				CMonster monster = world.monsters[i];
				if (monster.ClassName < 0) {
					continue;
				}
				++monsters;
				for (int j = 0; j < 4; ++j) {
					if (monster.PositionX >= xs[j] - border
							&& monster.PositionX <= xs[j] + border
							&& monster.PositionY >= ys[j] - border
							&& monster.PositionY <= ys[j] + border) {
						++cornC[j];
					}
				}
			}
			
			int monNear = 0;
			for (int i = 0; i < monstersN; ++i) {
				if (world.monsters[i].ClassName < 0) {
					continue;
				}
				float mx = world.monsters[i].PositionX;
				float my = world.monsters[i].PositionY;
				if (Math.abs(mx - px) < 0.25 && Math.abs(my - py) < 0.25) {
					++monNear;
				}
			}
			
			if (monNear > 80 && toGoX < -50) {
				double maxDist = 0;
//				System.err.println("yes");
				for (int i = 0; i < 4; ++i) {
					if (Math.hypot(xs2[i] - px, ys2[i] - py) > maxDist) {
						maxDist = Math.hypot(xs[i] - px, ys[i] - py);
						toGoX = xs2[i];
						toGoY = ys2[i];
					}
				}
			}
			
			if (state == 0 || state == 2) {

				float vx = 0f;
				float vy = 0f;

				flag = true;

				if (flag) {
					if (move % 30 == 0) {
						// double minScore = Double.POSITIVE_INFINITY;
						//
						// float bx = 0;
						// float by = 0;
						//
						// for (int i = 0; i < 150; ++i) {
						// float x = random.nextFloat() * (1 - border * 2)
						// + border;
						// float y = random.nextFloat() * (1 - border * 2)
						// + border;
						// double score = Math.sqrt(sq(x - px) + sq(y - py));
						// double minR = Double.POSITIVE_INFINITY;
						// int cnt = 0;
						// double sum = 0;
						// for (int j = 0; j < monstersN; ++j) {
						// CMonster monster = world.monsters[j];
						// if (monster.ClassName >= 0) {
						// double dist = Math.sqrt(sq(x
						// - monster.PositionX)
						// + sq(y - monster.PositionY));
						// minR = Math.min(minR, dist);
						// sum += dist;
						// ++cnt;
						// }
						// }
						// sum /= cnt;
						// score = Math.pow(score, 0.5);
						// score /= sum * minR;
						//
						// if (score < minScore) {
						// minScore = score;
						// bx = x;
						// by = y;
						// }
						// }
						//
						// vx = bx - px;
						// vy = by - py;

						double maxScore = Double.NEGATIVE_INFINITY;
						
						for (int i = 0; i < 150; ++i) {
							float x = random.nextFloat() * (1 - border * 2)
									+ border;
							float y = random.nextFloat() * (1 - border * 2)
									+ border;
							double a = py - y;
							double b = x - px;
							double c = - (a * x + b * y);
							
							double score = Double.POSITIVE_INFINITY;
							
							for (int j = 0; j < monstersN; ++j) {
								if (world.monsters[j].ClassName < 0) {
									continue;
								}
								float mx = world.monsters[j].PositionX;
								float my = world.monsters[j].PositionY;
								
								double distToUs = Math.sqrt(sq(mx - px) + sq(my - py));
								double distToLine = Math.abs(mx * a + my * b + c) / Math.sqrt(a * a + b * b);
								double ang = distToLine / distToUs;
								if ((x - px) * (mx - px) + (y - py) * (my - py) < 0) {
									ang = 1;
								}
								ang *= distToUs;
								score = Math.min(ang, score);
							}
							
							if (score > maxScore) {
								maxScore = score;
								vx = x - px;
								vy = y - py;
							}
						}

					} else {
						vx = lastVx;
						vy = lastVy;
					}
				}

				lastVx = vx;
				lastVy = vy;
				world.run(vx, vy);

				for (int i = 0; i < 4; ++i) {
					if (move > 60 * 20 && cornC[i] * 10 < monsters) {
						corner = i;
						state = 1;
//						System.err.println(1);
					}
				}
			} else if (state == 1) {
				if (Math.abs(xs[corner] - px) < 1e-2
						&& Math.abs(ys[corner] - py) < 1e-2) {
					corner = (corner + 1) % 4;
				}
				float vx = xs[corner] - px;
				float vy = ys[corner] - py;
				world.run(vx, vy);
				if (monsters < 50) {
					state = 2;
				}
			}
			
			if (Math.abs(toGoX - px) < 1e-2 && Math.abs(toGoY - py) < 1e-2) {
				toGoX = -100;
			}
			if (toGoX >= -50) {
				world.run(toGoX - px, toGoY - py);
			}


			int monId = -1;

			if (toKill >= 0 && world.monsters[toKill].ClassName >= 0
					&& world.monsters[toKill].HitPoints <= lastHp) {
				monId = toKill;
			} else {
				float scor = 1e20f;
				for (int i = 0; i < monstersN; i++) {
					CMonster monster = world.monsters[i];
					if (world.monsters[i].ClassName > 0.) {
						float llen = (float) Math.sqrt(sq(monster.PositionX
								+ monster.VelocityX - world.player.PositionX)
								+ sq(monster.PositionY + monster.VelocityY
										- world.player.PositionY))
								* world.monsters[i].HitPoints;
						if (state == 1 || state == 0) {
							double xx = monster.PositionX - px;
							double yy = monster.PositionY - py;
							float pvx = world.player.VelocityX;
							float pvy = world.player.VelocityY;
							double an = (xx * pvx + yy * pvy)
									/ (Math.sqrt(xx * xx + yy * yy) + Math
											.sqrt(pvx * pvx + pvy * pvy));
							if (an < -1) {
								an = -1;
							}
							if (an > 1) {
								an = 1;
							}
							an = Math.abs(Math.acos(an));
							if (an > Math.PI / 10) {
								continue;
							}
						}
						if (llen < scor) {
							scor = llen;
							monId = toKill = i;
						}
					}
				}
				if (monId == -1) {
					for (int i = 0; i < monstersN; i++) {
						CMonster monster = world.monsters[i];
						if (world.monsters[i].ClassName > 0.) {
							float llen = (float) Math.sqrt(sq(monster.PositionX
									+ monster.VelocityX
									- world.player.PositionX)
									+ sq(monster.PositionY + monster.VelocityY
											- world.player.PositionY))
									* world.monsters[i].HitPoints;
							if (llen < scor) {
								scor = llen;
								monId = toKill = i;
							}
						}
					}
				}
			}
			lastHp = world.monsters[toKill].HitPoints;
			world.shoot(world.monsters[monId].PositionX
					- world.player.PositionX, world.monsters[monId].PositionY
					- world.player.PositionY);

		}
	}

	private static float sq(float x) {
		return x * x;
	}
}
