#include "world.h"
#include <cstdio>
#include <cstring>
#include <cmath>

double rast(double x1,double y1, double x2,double y2){
  return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
}

double pl_x,pl_y;

double dalph=0.02;

int main(int argc, char** argv) {
	//Check for enough parameters
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP port\n");
		return 10;
	}

	//Create the world data (and establish connection with the server)
	World *world = new World(argv[1], atoi(argv[2]));
	float alpha = 0.0;
	struct monstr{
	    double x,y;
	    double rast;
	    double hitpoint;
	    int ind;
	};
    monstr monst[200];
    int countmonstr=0;
	int ind2=0;
	int col_wistr=1;
	int final_bullet[col_wistr];
	for (int i=0; i<col_wistr; i++){
	  final_bullet[i]=-1;
	}
	int pos_bullet=0;
	//Infinite loop
	while (true) {
		//Send our turn and receive the update of the game world
		world->makeMove();

		//Print some information
		printf("frame : %d, HP: %.2lf x: %.2lf y:%.2lf\n",
				world->player.Time, world->player.HitPoints,
				world->player.PositionX, world->player.PositionY);

		//alpha += dalph;
		//dalph *= 0.998;
		//Run in circles (set direction)
		
		world->run(cos(alpha), sin(alpha));


		double mas_x=0,mas_y=0;
		int total_monst=0;
       
        pl_x=world->player.PositionX;
        pl_y=world->player.PositionY;

		//Choose the first monster that is still alive
		for ( int j = 0; j < world->MAXMONSTERS; j++)
			if (world->monsters[j].ClassName >= 0) {
				//Shoot the bastard! (Shoot in the direction of the monster)

		        double rst=rast(world->monsters[j].PositionX,world->monsters[j].PositionY,pl_x,pl_y);
		        if (rst<0.05){				
					total_monst++;
					mas_x+=world->monsters[j].PositionX;
					mas_y+=world->monsters[j].PositionY;
				}
				if (countmonstr==0){

				    monst[0].x=world->monsters[j].PositionX;
				    monst[0].y=world->monsters[j].PositionY;
				    monst[0].rast=rast(monst[0].x,monst[0].y,pl_x,pl_y);
 				    monst[0].ind=j;
 				    countmonstr++;
				}else{
				    for (int i=0;i<countmonstr;i++){
				        if (rst<monst[i].rast){
                            for (int k=countmonstr; k>i;k--){
                               monst[k]=monst[k-1];
                            }
						    monst[i].x=world->monsters[j].PositionX;
						    monst[i].y=world->monsters[j].PositionY;
                            monst[i].rast=rst;
                            monst[i].ind=j;
                            if (countmonstr<5){countmonstr++;}
				        }
					}
				}

//				world->shoot(world->monsters[j].PositionX - world->player.PositionX,
//						   world->monsters[j].PositionY - world->player.PositionY);
			}
	

		for (int i=0; i<countmonstr; i++){
			int blt=0;
			for (int k=0; k<col_wistr; k++){
				if (final_bullet[k]==monst[i].ind){
					blt++;
				}
			}
			monst[i].hitpoint=world->monsters[monst[i].ind].HitPoints-blt*world->player.BulletDamage;
		}

		double hitp=0;
	    
	    for (int i=0; i<countmonstr; i++){
	    	if (monst[i].hitpoint>0){
	    		ind2=i;
	  			hitp=monst[i].hitpoint;
	  		}
		}
		for (int i=ind2+1; i<countmonstr; i++){
			if ((hitp>monst[i].hitpoint)&&(monst[i].hitpoint>0)){
				ind2=i;
				hitp=monst[i].hitpoint;
			}
		}

	    mas_x/=total_monst;
	    mas_y/=total_monst;

	    double mp_x=pl_x-mas_x;
		double mp_y=pl_y-mas_y;
		double z=rast(pl_x,pl_y,0.5,0.5);
		z*=15;

		srand(world->player.Time);
		int q=35;
		int rn=rand();

 		world->run(mp_y*z+mp_x,mp_y-mp_x*z);

		final_bullet[pos_bullet]=monst[ind2].ind;
 		pos_bullet=(++pos_bullet)%col_wistr;
 		world->shoot(monst[ind2].x-pl_x+cos(rn)/q,monst[ind2].y-pl_y+sin(rn)/q);

	}
	return 0;
}
