uses World;
var myworld : TWorld;
	port : longint;
	e, j : integer;
	alpha : real = 0.0;
begin
	{Check for enough parameters}
	if ParamCount < 2 then
    begin
		writeln('Parameters : ip port');
		halt(10);
	end;

	{Get port number}
	Val(ParamStr(2), port, e); 

	if (e <> 0) then
	begin
		writeln('Wrong port number!');
		halt(10);
	end;

	{Establish connection with the server}
	Open(ParamStr(1), port);

	{Infinite loop}
	while (true) do
	begin
		{Send our turn and receive the update of the game world}
		makeMove(myworld);

		{Print some information}
		writeln('Frame ', myworld.player.Time, ' HP: ', myworld.player.HitPoints:0:3, ' x: ', myworld.player.PositionX:0:3, ' y: ', myworld.player.PositionY:0:3);

		{Run in circles (set direction)}
		alpha := alpha +  0.02;
		run(myworld, cos(alpha), sin(alpha));	

		{Choose the first monster that is still alive}
		for  j := 1 to MAXMONSTERS do
			if (myworld.monsters[j].ClassName > 0) then
			begin
				{Shoot the bastard! (Shoot in the direction of the monster)}
				shoot(myworld, myworld.monsters[j].PositionX - myworld.player.PositionX, myworld.monsters[j].PositionY - myworld.player.PositionY);
				break;
			end;	
	end;

end.
