#ifndef GLOBAL_GAME_HEADER_987621
#define GLOBAL_GAME_HEADER_987621

//------------------------------------important defines here----------------------------

//no bounds check in VS vectors!
#define _SECURE_SCL 0

//use openmp?
//#define USE_OMP

//check for memory leaks in VS (debug only) ?
//#define _VS_MEM_LEAKS

//--------------------------------------------------------------------------------------

#ifdef _VS_MEM_LEAKS
	#define _CRTDBG_MAP_ALLOC
	#include <stdlib.h>
	#include <crtdbg.h>
#endif

//lazy to write standard includes all the time
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>
#include <memory>
#ifdef USE_OMP
	#include <omp.h>
#endif
#include "point.h"

#ifdef _WIN32
	inline double trandom() { return ((rand()<<15)^rand()) / double(1<<30); }
#else
	inline double trandom() { return rand() / double(RAND_MAX); }
#endif


//----------------------------------------------------------
//all the constants we want to tweak later should be here
//and in Director.cpp

//game field is a square with side = XXX
static const double FIELD_SIZE = 1.0;

//field with borders is divided into XXX x XXX pieces 
static const int GRID_SIZE = 64;
//border width to field size ratio
static const double GRID_OUTSIDE_WIDTH = 0.5;

//array sizes for entities
static const int MAX_PLAYER_COUNT = 1;
static const int MAX_MONSTER_COUNT = 256;
static const int MAX_MISSILE_COUNT = 256;

//Well... Generally I'll use this as a threshold=)
static const double EPS = 1e-9;
//and this as infinity
static const double INF = 1e+50;

//coef the velocity is multiplied by when hit
static const double MISSILE_IMPULSE_STOP = 0.0;
//amount any missile adds to velocity if hit
static const double MISSILE_IMPULSE_VELOCITY = 0.0;
#endif
