#include "Weapons.h"
#include "Entities.h"

void Cooldown::PassTime(double deltatime) {
	if (remaining > 0.0)
		remaining -= deltatime;
}

bool Cooldown::TimeToAct() {
	if (remaining <= 0.0) {
		remaining += period;
		return true;
	}
	return false;
}

bool MeleeWeapon::Bite(Entity *ent) {
	if (cooldown.TimeToAct()) {
		ent->hitpoints -= bitedamage;
		ent->velocity = double2();
		return true;
	}
	return false;
}

Missile *RangedWeapon::Shoot(double2 position, double2 direction) {
	if (cooldown.TimeToAct()) {
		if (!direction < EPS) return 0;
		Missile *res = new Missile(position, -1, bulletradius, bullethitpoints, bulletdamage);
		res->velocity = ForceVectorNorm(direction, bulletvelocity);
		return res;
	}
	return 0;
}
